/*
 * This file is generated by jOOQ.
 */
package nu.studer.sample.tables.records;


import java.util.UUID;

import javax.annotation.processing.Generated;

import nu.studer.sample.tables.Customer;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record3;
import org.jooq.Row3;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * Таблица пользователей
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.15.1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class CustomerRecord extends UpdatableRecordImpl<CustomerRecord> implements Record3<UUID, String, Boolean> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>selfbooster.customer.uuid</code>.
     */
    public CustomerRecord setUuid(UUID value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.customer.uuid</code>.
     */
    public UUID getUuid() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>selfbooster.customer.nickname</code>.
     */
    public CustomerRecord setNickname(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.customer.nickname</code>.
     */
    public String getNickname() {
        return (String) get(1);
    }

    /**
     * Setter for <code>selfbooster.customer.is_active</code>.
     */
    public CustomerRecord setIsActive(Boolean value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>selfbooster.customer.is_active</code>.
     */
    public Boolean getIsActive() {
        return (Boolean) get(2);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record3 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row3<UUID, String, Boolean> fieldsRow() {
        return (Row3) super.fieldsRow();
    }

    @Override
    public Row3<UUID, String, Boolean> valuesRow() {
        return (Row3) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Customer.CUSTOMER.UUID;
    }

    @Override
    public Field<String> field2() {
        return Customer.CUSTOMER.NICKNAME;
    }

    @Override
    public Field<Boolean> field3() {
        return Customer.CUSTOMER.IS_ACTIVE;
    }

    @Override
    public UUID component1() {
        return getUuid();
    }

    @Override
    public String component2() {
        return getNickname();
    }

    @Override
    public Boolean component3() {
        return getIsActive();
    }

    @Override
    public UUID value1() {
        return getUuid();
    }

    @Override
    public String value2() {
        return getNickname();
    }

    @Override
    public Boolean value3() {
        return getIsActive();
    }

    @Override
    public CustomerRecord value1(UUID value) {
        setUuid(value);
        return this;
    }

    @Override
    public CustomerRecord value2(String value) {
        setNickname(value);
        return this;
    }

    @Override
    public CustomerRecord value3(Boolean value) {
        setIsActive(value);
        return this;
    }

    @Override
    public CustomerRecord values(UUID value1, String value2, Boolean value3) {
        value1(value1);
        value2(value2);
        value3(value3);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached CustomerRecord
     */
    public CustomerRecord() {
        super(Customer.CUSTOMER);
    }

    /**
     * Create a detached, initialised CustomerRecord
     */
    public CustomerRecord(UUID uuid, String nickname, Boolean isActive) {
        super(Customer.CUSTOMER);

        setUuid(uuid);
        setNickname(nickname);
        setIsActive(isActive);
    }

    /**
     * Create a detached, initialised CustomerRecord
     */
    public CustomerRecord(nu.studer.sample.tables.pojos.Customer value) {
        super(Customer.CUSTOMER);

        if (value != null) {
            setUuid(value.getUuid());
            setNickname(value.getNickname());
            setIsActive(value.getIsActive());
        }
    }
}
